import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

/*
 * Implement choose_new_target and choose_train
 *
 * You have the following variables at your disposal:
 * num_players: number of bots
 * num_skills: number of skills
 * target: the current target
 * skill_difficulty: the difficulties of the skills
 * days_remaining: list for each player of this players skills. For each player there is a list of missing training per skill
 *    (i.e. it is the other way than in the description. It starts at s_i and ends at 0 once mastered)
 * player_selection: the last action for each player (i.e. which skill was chosen)
 * total_score: scores for each player total over all games
 * score: scores for each player of the current game
 * skill_unmastered: which skills have not yet a winner
 */

class randombot_java {

	protected Random rnd;
	protected int num_players, num_skills, target;
	protected int[] skill_difficulty, player_selection;
	protected double[] total_score, score;
	protected boolean[] skill_unmastered;
	protected int[][] days_remaining;

	protected int choose(List<Integer> list) {
		return list.get(rnd.nextInt(list.size()));
	}

	protected int choose_new_target(){
		List<Integer> pos = new ArrayList<>();
		for (int i = 0; i < num_skills; i++) {
			if (skill_unmastered[i]) {
				pos.add(i);
			}
		}
		return choose(pos);
	}

	protected int choose_train(){
		List<Integer> pos = new ArrayList<>();
		for (int i = 0; i < num_skills; i++) {
			if (days_remaining[0][i] > 1 || (days_remaining[0][i] == 1 && target == i)) {
				pos.add(i);
			}
		}
		return choose(pos);
	}

	protected void play(){
		rnd = new Random(42);
		Scanner cin = new Scanner(System.in);
		while(true) {
			num_players = cin.nextInt();
			num_skills = cin.nextInt();
			skill_difficulty = new int[num_skills];
			skill_unmastered = new boolean[num_skills];
			for (int i = 0; i < num_skills; i++) {
				skill_difficulty[i] = cin.nextInt();
				skill_unmastered[i] = true;
			}
			days_remaining = new int[num_players][num_skills];
			score = new double[num_players];
			player_selection = new int[num_players];
			for (int i = 0; i < num_players; i++) {
				System.arraycopy(skill_difficulty, 0, days_remaining[i], 0, num_skills);
				score[i] = 0;
			}
			if (total_score == null) {
				total_score = new double[num_players];
				for (int i = 0; i < num_players; i++) {
					total_score[i] = 0;
				}
			}

			while (true) {
				target = cin.nextInt();
				if (target == -3) {
					return;
				}
				List<Integer> winners = new ArrayList<>();
				for (int i = 0; i < num_players; i++) {
					player_selection[i] = cin.nextInt();
					if (player_selection[i] >= 0) {
						days_remaining[i][player_selection[i]] -= 1;
						if (days_remaining[i][player_selection[i]] == 0) {
							winners.add(i);
							skill_unmastered[player_selection[i]] = false;
						}
					}
				}
				for (int winner : winners) {
					score[winner] += 1.0 / winners.size();
					total_score[winner] += 1.0 / winners.size();
				}

				if (target == -1){
					target = choose_new_target();
					System.out.println(target);
					System.out.flush();
				} else if (target == -2){
					break;
				}

				System.out.println(choose_train());
				System.out.flush();
			}
		}
	}

	public static void main(String[] args) {
		new randombot_java().play();
	}
}