import scala.collection.mutable.ListBuffer
import scala.io.StdIn
import scala.util.Random

/*
 * Implement choose_new_target and choose_train
 *
 * You have the following variables at your disposal:
 * num_players: number of bots
 * num_skills: number of skills
 * target: the current target
 * skill_difficulty: the difficulties of the skills
 * days_remaining: list for each player of this players skills. For each player there is a list of missing training per skill
 *    (i.e. it is the other way than in the description. It starts at s_i and ends at 0 once mastered)
 * player_selection: the last action for each player (i.e. which skill was chosen)
 * total_score: scores for each player total over all games
 * score: scores for each player of the current game
 * skill_unmastered: which skills have not yet a winner
 */

object randombot_scala {

  var num_players, num_skills, target : Int = 0
  var skill_difficulty, player_selection : Array[Int] = new Array[Int](0)
  var total_score, score : Array[Double] = new Array[Double](0)
  var skill_unmastered : Array[Boolean] = new Array[Boolean](0)
  var days_remaining : Array[Array[Int]] = new Array[Array[Int]](0)

  def choose_new_target(): Int ={
    Random.shuffle(for(x <- 0 until num_skills if skill_unmastered(x)) yield x).head
  }

  def choose_train(): Int ={
    Random.shuffle(for(x <- 0 until num_skills if days_remaining(0)(x) > 1 || (days_remaining(0)(x) == 1 && target == x)) yield x).head
  }

  def main(args: Array[String]): Unit ={
    var outer_playing, inner_playing = true
    while(outer_playing){
      val n_and_m = StdIn.readLine().split(" ").map(_.toInt)
      num_players = n_and_m(0)
      num_skills = n_and_m(1)
      skill_difficulty = StdIn.readLine().split(" ").map(_.toInt)
      days_remaining = new Array[Array[Int]](num_players).map(_ => skill_difficulty.clone)
      score = new Array[Double](num_players)
      skill_unmastered = new Array[Boolean](num_skills).map(_ => true)
      if (total_score.length == 0) {
        total_score = new Array[Double](num_players)
      }
      inner_playing = true
      while(inner_playing) {
        target = StdIn.readInt()
        if (target == -3) {
          inner_playing = false
          outer_playing = false
        } else {
          player_selection = StdIn.readLine().split(" ").map(_.toInt)
          val winners = new ListBuffer[Int]
          for ((x, i) <- player_selection.view.zipWithIndex if x >= 0) {
            days_remaining(i)(x) -= 1
            if (days_remaining(i)(x) == 0) {
              winners += i
              skill_unmastered(x) = false
            }
          }
          for (winner <- winners) {
            score(winner) += 1.0 / winners.length
            total_score(winner) += 1.0 / winners.length
          }

          if (target == -1) {
            target = choose_new_target()
            println(target)
          } else if (target == -2) {
            inner_playing = false
          }
          if (target != -2){
            println(choose_train())
          }
        }
      }
    }
  }
}
